<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="Scanning|Host Management">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>Advanced Search</title>
        
        <link href="../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../index.html#07-scanning/advanced-host-searching.html">Open topic with navigation</a>
        </p>
        <h1>Advanced Search</h1>
        <p>When you perform a basic search, Metasploit searches all columns in the hosts table. Oftentimes, the search may not be specific enough and returns records that are false positives. For example, if you perform a basic search for <code class="usertype">Windows</code>, the results may include all hosts that have <code class="usertype">Windows</code> somewhere in the description, and not hosts that are Windows specific machines. </p>
        <p>To work around false positives, you can perform an advanced search. In an advanced search, you specify exactly where in the hosts table you want the search to look.This is particularly useful when you want to narrow the results to a specific subset of data. </p>
        <h2>Parts of a Advanced Search Query</h2>
        <p>An advanced search query is made up of three parts: </p>
        <ul>
            <li value="1"><b>Search Filter</b> - Refers to the column in the table where you want the search to look.</li>
            <li value="2"><b>Search Operator</b> - Refers to the operators that you can add to narrow or broaden a search query. A search operator is also known as a connector. </li>
            <li value="3"><b>Keyword</b> - Refers to a single word or phrase that the search uses to find matching records. </li>
        </ul>
        <p>To create an advanced search query, you need to first specify the search filter, followed by the search operator and keyword. Going back to the previous example, if you want to only see hosts that are Windows specific machines, you would use the following search query: <code class="usertype">os:windows</code>. This query ensures that the search only looks in the OS column of the hosts tables for the <code class="usertype">Windows</code> keyword  and only returns hosts that have been fingerprinted as Windows systems.</p>
        <h3>Search Operators</h3>
        <p><span class="VariablesProductName">Metasploit Pro</span> provides several different types of search operators that you can use to refine your host search. The search operator that you  need to use depends on the type of data that you want the search to find. </p>
        <p class="SubHeading1">Text Operators</p>
        <p>You should use text operators when you want to perform a full-text search. Typically, you use text operators when you search for any data other than ports or IP addresses. </p>
        <p>Like operator (:) - Add the LIKE&#160;operator to a search query to include all records that have the keyword in the specified column. </p>
        <p> For example, if you search for <code class="usertype">os:windows</code>, the search shows any hosts with the keyword, <code class="usertype">Windows</code>, in the <b class="UISelection">OS </b>field.</p>
        <p>Not like operator (!:)</p>
        <table style="width: 100%;border-left-style: none;border-left-width: 0px;border-left-color: #a9a9a9;border-right-style: none;border-right-width: 0px;border-right-color: #a9a9a9;border-top-style: none;border-top-width: 0px;border-top-color: #a9a9a9;border-bottom-style: none;border-bottom-width: 0px;border-bottom-color: #a9a9a9;border-collapse: collapse;margin-left: auto;margin-right: auto;">
            <col style="width: 70px;" />
            <col />
            <thead>
                <tr>
                    <th style="text-align: center;background-color: #dcdcdc;">Search Operator</th>
                    <th style="background-color: #dcdcdc;">Description </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td style="text-align: center;">
                        <p>Like Operator (:)</p>
                    </td>
                    <td>
                        <p>Add the LIKE&#160;operator to a search query to include all records that have the keyword in the specified column. </p>
                        <p> For example, if you search for <code class="usertype">os:windows</code>, the search shows any hosts with the keyword, <code class="usertype">Windows</code>, in the <b class="UISelection">OS </b>field.</p>
                    </td>
                </tr>
                <tr>
                    <td style="text-align: center;">
                        <p>Not Like Operator (!:)</p>
                    </td>
                    <td>
                        <p>Add the NOT&#160;LIKE operator to a search query to exclude records that have the keyword in the specified column. </p>
                        <p>For example, if you search for <code class="usertype">os!:windows</code>, the search does not return any records that contain the keyword, <code class="usertype">Windows</code>, in the <b class="UISelection">OS&#160;</b>field.</p>
                    </td>
                </tr>
                <tr>
                    <td style="text-align: center;">
                        <p>Equals Operator (=)</p>
                    </td>
                    <td>
                        <p>Add the EQUALS operator to a search query  to return an exact match. </p>
                        <p>For example, if you search for <code class="usertype">os=Windows</code>, the search shows all hosts that match the keyword, <code class="usertype">Windows</code>, in the <b class="UISelection">OS </b>field. However, if the operating system for the host is listed as <code class="usertype">Microsoft&#160;Windows</code>, these records will not appear in the results because they do not match the query exactly. </p>
                    </td>
                </tr>
                <tr>
                    <td style="text-align: center;">
                        <p>Not Equals Operator (&lt;&gt;)</p>
                    </td>
                    <td>
                        <p>Add the NOT&#160;EQUALS operator to exclude records that contain the keyword. </p>
                        <p>For example, if you search for <code class="usertype">os&lt;&gt;Windows</code>, the search excludes hosts that exactly match the keyword, <code class="usertype">Windows</code>, in the <b class="UISelection">OS </b>field. However, if the operating system for the host is listed as <code class="usertype">Microsoft&#160;Windows</code>, these records will appear in the results because they do not match the query. </p>
                    </td>
                </tr>
                <tr>
                    <td style="text-align: center;">
                        <p>And Operator (&amp;&amp;)</p>
                    </td>
                    <td>
                        <p>Add the AND operator to a query to combine multiple keywords or search criteria. The AND operator requires that all the keywords or search criteria appear in the results.</p>
                        <p>For example, if you search for <code class="usertype">os:windows &amp;&amp; sp0</code>, the search returns the hosts that match both criteria. </p>
                    </td>
                </tr>
                <tr>
                    <td style="text-align: center;">
                        <p>Or Operator (||)</p>
                    </td>
                    <td>
                        <p>Add the OR operator to a search query to  include any of your search terms in the resulting records. You can use the OR operator to broaden your search.</p>
                        <p>For example, if you search for <code class="usertype">os:Windows || ip:192.168</code>, the search finds hosts that are running Windows or have a IP address that starts with 192.168. The hosts do not have to match both search criteria.</p>
                    </td>
                </tr>
            </tbody>
        </table>
        <p class="SubHeading1">Numeric Operators</p>
        <p>You should use numeric operators when you search for integer values or when you want to compare numeric values. Typically, you use numeric operators when you search for IP addresses or ports. </p>
        <table style="width: 100%;border-left-style: none;border-left-width: 0px;border-left-color: #a9a9a9;border-right-style: none;border-right-width: 0px;border-right-color: #a9a9a9;border-top-style: none;border-top-width: 0px;border-top-color: #a9a9a9;border-bottom-style: none;border-bottom-width: 0px;border-bottom-color: #a9a9a9;border-collapse: collapse;margin-left: auto;margin-right: auto;">
            <col />
            <col />
            <thead>
                <tr>
                    <th style="background-color: #dcdcdc;">Search Operator</th>
                    <th style="background-color: #dcdcdc;">Description </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <p class="tableCell">Equal Operator (= or :)</p>
                    </td>
                    <td>
                        <p>Add the equal operator to perform a mathematical equivalency check. </p>
                        <p>For example, if you search for <code class="usertype">port:445</code>, the search shows all services that are open on that port. </p>
                    </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Not Equal Operator (&lt;&gt; or !:)</p>
                    </td>
                    <td>
                        <p>Add the not equal operator to perform a mathematical non-equivalency check. </p>
                        <p>For example, if you search for <code class="usertype">port!:445</code>, the search returns all services except those that are open on port 445. </p>
                    </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Comparison Operator (&lt;, &lt;=, &gt; or, &gt;=)</p>
                    </td>
                    <td>
                        <p>Add a comparison operator to compare two values. </p>
                        <p>For example, if you search for <code class="usertype">vulns&gt;0</code>, the search only shows hosts that have vulnerabilities.</p>
                    </td>
                </tr>
            </tbody>
        </table>
        <p class="SubHeading1">Tag Operators</p>
        <p>You should use tag operators when you search for host tags.</p>
        <table style="width: 100%;border-left-style: none;border-left-width: 0px;border-left-color: #a9a9a9;border-right-style: none;border-right-width: 0px;border-right-color: #a9a9a9;border-top-style: none;border-top-width: 0px;border-top-color: #a9a9a9;border-bottom-style: none;border-bottom-width: 0px;border-bottom-color: #a9a9a9;border-collapse: collapse;margin-left: auto;margin-right: auto;">
            <col />
            <col />
            <thead>
                <tr>
                    <th style="background-color: #dcdcdc;">Search Operator</th>
                    <th style="background-color: #dcdcdc;">Description </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <p class="tableCell">Hash Sign (#)</p>
                    </td>
                    <td>
                        <p>Append the hash sign to any host tag to search for hosts. </p>
                        <p>For example, if you search for <code class="usertype">#windows</code>, the search shows any hosts that have the <code class="usertype">windows </code>host tag. </p>
                    </td>
                </tr>
            </tbody>
        </table>
        <h3>Search Filters</h3>
        <p>In Metasploit, a search filter refers to a column of data in the hosts table. You specify a search filter to specify where you want the search to look in the hosts table. For example, if you want to search for hosts based on the operating system, you should use the <b class="UISelection">os </b>search filter. </p>
        <p>The search filters that are available depend on the page that you are currently viewing in the Analysis area. When you perform a search, you can only use the search filters that are available for that specific page. Some search filters are global, such as <b class="UISelection">hostname </b>and <b class="UISelection">OS</b>; however, there are some that are specific to the page that you are viewing, such as <b class="UISelection">proto </b>or <b class="UISelection">ref</b>. </p>
        <p>There are five different pages that you can view from the <b class="UISelection">Analysis </b>area and each has its own set of search filters: </p>
        <ul>
            <li value="1">Hosts </li>
            <li value="2">Notes</li>
            <li value="3">Services</li>
            <li value="4">Vulnerabilities</li>
            <li value="5">Captured Data</li>
        </ul>
        <p>Read the following sections to learn more about the search filters that each page supports. </p>
        <p class="SubHeading1">Hosts Page</p>
        <p>The Hosts Page enumerates all hosts that have been fingerprinted. To access the Hosts page, select <b class="UISelection">Analysis &gt;&#160;Hosts</b> from the Tasks bar. </p>
        <table style="border-collapse: collapse;border-spacing: 1px 1px;border-left-style: none;border-left-width: 0px;border-left-color: #a9a9a9;border-right-style: none;border-right-width: 0px;border-right-color: #a9a9a9;border-top-style: none;border-top-width: 0px;border-top-color: #a9a9a9;border-bottom-style: none;border-bottom-width: 0px;border-bottom-color: #a9a9a9;margin-left: auto;margin-right: auto;">
            <col style="width: 100px;" />
            <col style="width: 500px;" />
            <thead>
                <tr>
                    <th style="background-color: #dcdcdc;">Search Filter</th>
                    <th style="background-color: #dcdcdc;">Description </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <p class="tableCell">Hostname</p>
                    </td>
                    <td>Refers to the host name, or nickname,that uniquely identifies the machine.</td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">OS</p>
                    </td>
                    <td>Refers to the operating system that runs on the host. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Version</p>
                    </td>
                    <td>Refers to the version of the operating system that the host runs, such as Windows 2000. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Purpose</p>
                    </td>
                    <td>Identifies whether the host is a client, server, or device. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">IP</p>
                    </td>
                    <td>Refers to the IP&#160;address of a host. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Vulns</p>
                    </td>
                    <td>Identifies the number of vulnerabilities that has been identified for a host.</td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Services</p>
                    </td>
                    <td>Identifies the number of services that has been found for a host. </td>
                </tr>
            </tbody>
        </table>
        <p class="SubHeading1">Notes Page</p>
        <p>The Notes page shows any additional information that Metasploit was able to obtain from the hosts. Notes are bits of information that Metasploit is able to obtain from a host, but are not easily sorted into existing table columns.To access the Notes page, select <b class="UISelection">Analysis &gt;&#160;Notes</b>from the Tasks bar. </p>
        <table style="border-collapse: collapse;border-spacing: 1px 1px;border-left-style: none;border-left-width: 0px;border-left-color: #a9a9a9;border-right-style: none;border-right-width: 0px;border-right-color: #a9a9a9;border-top-style: none;border-top-width: 0px;border-top-color: #a9a9a9;border-bottom-style: none;border-bottom-width: 0px;border-bottom-color: #a9a9a9;margin-left: auto;margin-right: auto;">
            <col />
            <col />
            <thead>
                <tr>
                    <th style="background-color: #dcdcdc;">Search Filter</th>
                    <th style="background-color: #dcdcdc;">Description </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <p class="tableCell">Hostname</p>
                    </td>
                    <td>Refers to the host name, or nickname,that uniquely identifies the machine.</td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Type</p>
                    </td>
                    <td>Identifies the method or source used to obtain the note, such as from an import or fingerprint.</td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">IP</p>
                    </td>
                    <td>Refers to the IP&#160;address of a host. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Data</p>
                    </td>
                    <td>Refers to the information stored in the note. </td>
                </tr>
            </tbody>
        </table>
        <p class="SubHeading1">Services Page</p>
        <p>The Services Page shows all services that Metasploit was able to enumerate for open ports.To access the Services page, select <b class="UISelection">Analysis &gt;&#160;Services</b> from the Tasks bar. </p>
        <table style="width: 100%;border-left-style: none;border-left-width: 0px;border-left-color: #a9a9a9;border-right-style: none;border-right-width: 0px;border-right-color: #a9a9a9;border-top-style: none;border-top-width: 0px;border-top-color: #a9a9a9;border-bottom-style: none;border-bottom-width: 0px;border-bottom-color: #a9a9a9;border-collapse: collapse;margin-left: auto;margin-right: auto;">
            <col />
            <col />
            <thead>
                <tr>
                    <th style="background-color: #dcdcdc;">Search Filter</th>
                    <th style="background-color: #dcdcdc;">Description </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <p class="tableCell">Hostname</p>
                    </td>
                    <td>Refers to the host name, or nickname,that uniquely identifies the machine.</td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Name</p>
                    </td>
                    <td>Refers to the active services that are active on the port, such as DCERPC, HTTP, and SSH. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Proto</p>
                    </td>
                    <td>Refers to the protocol that the port runs, such as TCP or UDP. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Info</p>
                    </td>
                    <td>Identifies the operating system and version that the host runs. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">IP</p>
                    </td>
                    <td>Refers to the IP&#160;address of a host. </td>
                </tr>
            </tbody>
        </table>
        <p class="SubHeading1">Vulnerabilities Page</p>
        <p>The Vulnerabilities Page shows all vulnerabilities that Metasploit was able to identify for the hosts in a project. To access the Vulnerabilities page, select <b class="UISelection">Analysis &gt;&#160;Vulnerabilities</b>from the Tasks bar. </p>
        <table style="width: 100%;border-left-style: none;border-left-width: 0px;border-left-color: #a9a9a9;border-right-style: none;border-right-width: 0px;border-right-color: #a9a9a9;border-top-style: none;border-top-width: 0px;border-top-color: #a9a9a9;border-bottom-style: none;border-bottom-width: 0px;border-bottom-color: #a9a9a9;border-collapse: collapse;margin-left: auto;margin-right: auto;">
            <col />
            <col />
            <thead>
                <tr>
                    <th style="background-color: #dcdcdc;">Search Filter</th>
                    <th style="background-color: #dcdcdc;">Description </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <p class="tableCell">Hostname</p>
                    </td>
                    <td>Refers to the host name, or nickname,that uniquely identifies the machine.</td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Info</p>
                    </td>
                    <td>Refers to the description of the vulnerability. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Ref</p>
                    </td>
                    <td>Refers to the vulnerability reference ID. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">IP</p>
                    </td>
                    <td>Refers to the IP&#160;address of a host. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Name</p>
                    </td>
                    <td>Refers to the name of the vulnerability. </td>
                </tr>
            </tbody>
        </table>
        <p class="SubHeading1">Captured Data Page</p>
        <p>The Captured Data page lists all data that Metasploit was able to obtain from the hosts in a project. From this page, you can view and download captured data.To access the Captured Data page, select <b class="UISelection">Analysis &gt;&#160;Captured Data</b>from the Tasks bar. </p>
        <table style="width: 100%;border-left-style: none;border-left-width: 0px;border-left-color: #a9a9a9;border-right-style: none;border-right-width: 0px;border-right-color: #a9a9a9;border-top-style: none;border-top-width: 0px;border-top-color: #a9a9a9;border-bottom-style: none;border-bottom-width: 0px;border-bottom-color: #a9a9a9;border-collapse: collapse;margin-left: auto;margin-right: auto;">
            <col />
            <col />
            <thead>
                <tr>
                    <th style="background-color: #dcdcdc;">Search Filter</th>
                    <th style="background-color: #dcdcdc;">Description </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <p class="tableCell">Hostname</p>
                    </td>
                    <td>Refers to the host name, or nickname,that uniquely identifies the machine.</td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Info</p>
                    </td>
                    <td>Refers to the description of the vulnerability. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">IP</p>
                    </td>
                    <td>Refers to the IP&#160;address of a host. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Type</p>
                    </td>
                    <td>Refers to the captured data type, such as a shadow file, private or public key, or a process list. </td>
                </tr>
                <tr>
                    <td>
                        <p class="tableCell">Name</p>
                    </td>
                    <td>Refers to the name of the vulnerability.</td>
                </tr>
            </tbody>
        </table>
        <h2>Advanced Keyword Search Examples</h2>
        <p>The following sections provide some examples of searches that you may want to perform. </p>
        <p class="SubHeading1">Searching for Services Running on a Specific Port</p>
        <p>To search for services on port 445, enter the following query in the search field: <code class="usertype">port:445</code> .The search returns all services for that port. </p>
        <p class="SubHeading1">Searching for OS Specific Hosts</p>
        <p>To search for Linux hosts, enter the following query in the search field: <code class="usertype">os:linux</code>. The search returns hosts that have been fingerprinted as Linux systems. </p>
        <p class="SubHeading1">Searching for Hosts with Known Vulnerabilities </p>
        <p>To search for hosts that have vulnerabilities, enter the following query in the search field: <code class="usertype">vulns&gt;0</code>. The search returns any host that has at least one vulnerability. </p>
        <p class="SubHeading1">Excluding Hosts from a Search </p>
        <p>To exclude the host 10.0.0.2 from a search, enter the following query in the search field: ip!:<code class="usertype">10.0.0.2</code>. The search displays all hosts except for the one that has been explicitly excluded. </p>
        <p class="SubHeading1">Excluding a Range of Hosts</p>
        <p>To exclude any host in the 10.0.0/24 range, enter the following query in the search field: ip!:10.0.0. The search displays all hosts except for the ones that fall into the range specified.</p>
        <p class="SubHeading1">Searching for a Host Tag</p>
        <p>To search for all host that have the host tag, <code class="usertype">NexposeImport</code>, enter the following query in the search field: <code class="usertype">#NexposeImport</code>. The search returns any host that has been tagged with the <code class="usertype">NexposeImport</code> host tag. </p>
        <h2>Nested Searches</h2>
        <p>Nesting is an advanced search strategy that enables you to build a more complex and precise search query. When you create a nested search query, you use parentheses to group search terms together with search operators and define the order in which they are processed. Each set of keywords that are enclosed in parentheses is processed as a single unit. </p>
        <p>Since Boolean logic operates on mathematical principles, the search expressions defined within parentheses take precedence over those that are not. If there is more than one set of parentheses, the innermost set of parentheses is processed first, then the next, and so on until the entire query has been interpreted. The search engine supports infinite levels of nesting. </p>
        <p class="Note" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>The AND operator takes precedence over the OR operator when the search query is parsed.</p>
        <h3>Nested Search Example</h3>
        <p>Let's say that you want to search for hosts that are Windows systems and are in the 192.168.1.0 or 192.168.2.0 subnets. </p>
        <p>If  you enter a basic search query, such as <code class="usertype">os:windows &amp;&amp; 192.168.1 || 192.168.2</code>, the search parses the query from left to right. It searches for Windows systems that are in the 192.168.1.0 subnet or any system that is in the 192.168.2.0 subnet. This query does not return the results that you want. </p>
        <p>To get the results you want, you need to create a nested search query, so that you can group relevant keywords together and define the sequence in which each set of keywords are processed. Using the previous example, you can enter the following nested search query: <code class="usertype">os:windows &amp;&amp; (192.168.1 || 192.168.2)</code>. This query first searches for hosts that fall into either of the specified subnets, and then parses those results down to Windows systems.  </p>
        <h3>Multi-Level Nested Search Example </h3>
        <p>Now let's say that you want to fine -tune your search even further, and you want to find hosts that are Windows systems that are in the 192.168.1.0 or 192.168.2.0 subnets and have Service Pack 1 or 2 installed. </p>
        <p>In this case, you can use multiple levels of nesting. You can search for <code class="usertype">(os:windows &amp;&amp; ((192.168.1 || 192.168.2) &amp;&amp; (sp1 || sp2)))</code>. The search looks at the innermost set of parentheses first, which means it has to search for hosts that fall within one of the specified subnets and have Service Pack 1 or 2 installed. If there are hosts that match conditions, the search then parses the resulting list for Windows systems.  </p>
    </body>
</html>